using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.ConnectionEngine.Common.Security;
using System.Xml;

using common = Microsoft.ConnectionEngine.Common;
using Microsoft.ConnectionEngine.Registers.Health.Patient.Common;
using business = Microsoft.ConnectionEngine.Registers.Health.Patient.Business;
using Microsoft.ConnectionEngine.Registers.Core.ServiceProvider.Common;

namespace Microsoft.ConnectionEngine.Registers.Health.Patient.Facade
{
    class Utilities
    {
        public static HSDPrincipal CreateUser(System.Xml.XmlNode userNode, System.Xml.XmlNamespaceManager nsmgr)
        {
            string userName = userNode.SelectSingleNode("//pat:UserName", nsmgr).InnerText;
            string password = userNode.SelectSingleNode("//pat:Password", nsmgr).InnerText;

            return business.SecurityManager.ValidateUser(userName, password);
        }


        //ValidateUser = 2000
        public static void ValidateUser(XmlDocument xmlMessage, out XmlDocument resultXmlMessage, out int resultMsgType)
        {
            XmlNamespaceManager nsmgr = new XmlNamespaceManager(xmlMessage.NameTable);
            nsmgr.AddNamespace("pat", xmlMessage.FirstChild.NamespaceURI);

			XmlNode userCredentials = xmlMessage.SelectSingleNode("//pat:UserCredentials", nsmgr);
			HSDPrincipal principal = Utilities.CreateUser(userCredentials, nsmgr);   

            resultXmlMessage = new XmlDocument();

            //create a responsePayload string from the principal object if it isn't null:
            if (principal != null)
            {
                resultXmlMessage.LoadXml(common.Utilities.SerializeObject(principal, typeof(HSDPrincipal)));
            }

            resultMsgType = (int)MessageTypes.PrincipalResult;
        }


    }
}
