using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using Microsoft.ConnectionEngine.Common;
using Microsoft.ConnectionEngine.Registers.Core.ServiceProvider;


/// <summary>
/// Summary description for CollaborationEngineAdapter
/// </summary>
[WebService(Namespace = "http://Microsoft.ConnectionEngine.Services")]
public class ConnectionEngineAdapter : System.Web.Services.WebService
{
    private static SystemAdapter hsdAdapter;

    public SystemAdapter HSDAdapter
    {
        get
        {
            if (hsdAdapter == null)
                hsdAdapter = new SystemAdapter();
            return hsdAdapter;
        } 
    }

    public ConnectionEngineAdapter()
    {
    }

    [WebMethod]
    public ConnectionEngineMessage SendConnectionEngineMessage(object objMessage, int msgType, Guid conversationID, string destinationID)
    {
        ConnectionEngineMessage result = HSDAdapter.SendConnectionEngineMessage(objMessage, msgType, conversationID, destinationID);
        return result;
    }

    [WebMethod]
    public ConnectionEngineMessage ReceiveConnectionEngineMessage(ConnectionEngineMessage connectionEngineMessageRequest)
    {
        ConnectionEngineMessage result = HSDAdapter.ReceiveConnectionEngineMessage(connectionEngineMessageRequest);
        return result;
    }

    [WebMethod]
    public string GetInteractiveSessionInformation(string serviceproviderid, int messagetypeid, System.Collections.Generic.List<KeyValueItem> args)
    {
        string result = HSDAdapter.GetInteractiveSessionInformation(serviceproviderid, messagetypeid, args);
        return result;
    }
			
    
}

